#ifndef _RESUMPTIONTOKEN_H_
#define _RESUMPTIONTOKEN_H_

#include <vector>

#include "text_t.h"

// use the standard namespace
#if !defined (GSDL_NAMESPACE_BROKEN)
#if defined(GSDL_USE_OBJECTSPACE)
using namespace ospace::std;
#else
using namespace std;
#endif
#endif

class ResumptionToken
{ private:
  text_t  collection;
  text_t  browseNode;
  vector<int> browsePosition;
  int     startItem;
  text_t  buildDate;
  // TODO: add a server name to the variables list; see getToken in resumptionToken.cpp

 public:
  ResumptionToken(const text_t &collection, const text_t &rootNode, const text_t &buildDate);
  ResumptionToken(const text_t &URN);
  text_t  getToken();

  void setPosition(const text_t &node, int startItem);

  text_t  getCollection() { return collection; }
  text_t  getNode() { return browseNode; }
  int     getPosition() { return startItem; }
  int     getOffsetDepth() { return this->browsePosition.size(); }
  void    setOffset(int depth, int position) { this->browsePosition[depth] = position; }
  int getOffset(int offset) { return this->browsePosition[offset]; }
  bool isValid();
};

#endif
